-- CLCProt 3.1.5.03 for WoW 5.4 Mists of Pandaria
-- by Adeya, player of Paladin DyeimiAdeya currently on Garona_US
--
--   The CLCProt 3.x files include "YOU MUST READ ME NOW" (.rtf), which has  
-- that name because it is true. :-) It is in the same folder as clcprot.lua.
--
--   The prior source code for CLC Prot 3.x is in the files of "CLCProt 2.0
-- for MoP 5.4" by Blue Warlord. All files were downloaded from Curse.com. The 
-- code for creating the Rotation tabs is modeled on code in the extant CLCRet. 
-- Comments by Adeya are identified by the string "--dA:". 
--
--  See also the comments at the beginning of rotation.lua.
--
-- COURTESY NOTICE: the Lua scripting language is Copyright © 1994–2014 Lua.org, 
-- PUC-Rio. The Lua license is available at http://www.lua.org/license.html
--
-------------------------------------------------------------------------------=

local _, trueclass = UnitClass("player")
if trueclass ~= "PALADIN" then return end					--dA: return to where? to what? (rhetorical questions ... or not?)

if ( UnitLevel("player") < 45 ) then 
	message("The paladin must be Level 45 or higher to use CLCProt!")
end

clcprot = LibStub("AceAddon-3.0"):NewAddon("clcprot", "AceEvent-3.0", "AceConsole-3.0")

local GetTime = GetTime

-- shortcut for db options
local db

local dq = { 31935, 31935 }			--dA: 31935 is avenger's shield id 
local nq = {}
nq[1] = GetSpellInfo(31935)
nq[2] = GetSpellInfo(31935)

local hrname = GetSpellInfo(53595)	--dA: 53595 is hammer of the righteous id

-- main and secondary skill buttons
local buttons = {}
-- configurable buttons
local auraButtons = {}
local enabledAuraButtons
local numEnabledAuraButtons 
local auraIndex

local icd = {}
local playerName

-- addon status
local addonEnabled = false			-- enabled
local addonInit = false				-- init completed
clcprot.locked = true				-- main frame locked

--[[
clcprot.auraButtons = auraButtons
clcprot.icd = icd
--]]

local MAX_AURAS = 20
local BGTEX = "Interface\\AddOns\\clcprot\\textures\\minimalist"
local BORDERTEX = "Interface\\AddOns\\clcprot\\textures\\border"
local borderType = {
	"Interface\\AddOns\\clcprot\\textures\\border",					-- light
	"Interface\\AddOns\\clcprot\\textures\\border_medium",			-- medium
	"Interface\\AddOns\\clcprot\\textures\\border_heavy"			-- heavy
}

local strataLevels = {
	"BACKGROUND",
	"LOW",
	"MEDIUM",
	"HIGH",
	"DIALOG",
	"FULLSCREEN",
	"FULLSCREEN_DIALOG",
	"TOOLTIP",
}


-----------------------------------------------------------------------------------------------------------------------
-- global variables					--dA: most of these are given values in clcprot.lua, and used also in rotation.lua
-----------------------------------------------------------------------------------------------------------------------

  s_sht = false			-- true while the Tier 3 Level 45 Selfless Healer talent is currently selected (added)
  s_eft = false			-- true while the Tier 3 Level 45 Eternal Flame talent is currently selected (added)
  s_sst = false			-- true while the Tier 3 Level 45 Sacred Shield talent is currently selected (added)

  s_hat = false			-- true while the Tier 5 Level 75 Holy Avenger talent is currently selected (added)
  s_swt = false			-- true while the Tier 5 Level 75 Sanctified Wrath talent is currently selected (added)
  s_dpt = false			-- true while the Tier 5 Level 75 Divine Purpose talent is currently selected (added)
  
  s_hprt = false		-- true while the Tier 6 Level 90 Holy Prism talent is currently selected (added)
  s_lht  = false		-- true while the Tier 6 Level 90 Light's Hammer talent is currently selected (added)
  s_est  = false		-- true while the Tier 6 Level 90 Execution Sentence talent is currently selected (added)

  s_goc = false			-- true while the Glyph of Consecration is in effect (added)
  consId = 26573		-- Consecration ID, depending upon whether GoC is in effect (without glyph is default)
  s_gfw = false			-- true while the Glyph of Final Wrath is in effect (added)
  allowWBhpmax = false	-- true while applying or refreshing Weakened Blows allowed if HP >=5 (added)

  prioToggled = "no"	-- value changes to "qn" or "qa" when the priority sequence switches to normal or alternate
    
  s1_twm = false		-- true while the AoE of the spell in s1 must be chosen with a mouse (added)
  s2_twm = false		-- true while the AoE of the spell in s2 must be chosen with a mouse (added)

  rota = 0				-- tally of calls to clcprot.ProtRotation() since CLCProt was loaded (debugging) (added)
  t_rspan = 0.000		-- time span between the start of a rotation and the start of the next rotation (added)
	
----: globals initialized in rotation.lua:

  -- actions						-- Sd: object defined in rotation.lua containing data & methods for actions

-- ---------------------------------------------------------------------------------------------------------------------
-- DEFAULT VALUES
-- ---------------------------------------------------------------------------------------------------------------------

local ptuCount = 0					--dA: tally of calls to clcprot:PLAYER_TALENT_UPDATE() for workaround (added) 
local L45name = ""
local L75name = ""
local L90name = ""

local defaults = 
{
	profile = 
	{
		version = 6,
		
		-- layout settings for the main frame (the black box you toggle on and off)\
		zoomIcons = true,
		noBorder = false,
		borderColor = {0, 0, 0, 1},
		borderType = 2,
		x = 500,
		y = 300,
		scale = 1,
		alpha = 1,
		show = "always",
		fullDisable = false,
		strata = 3,
		grayOOM = false,
		
		-- paladin power bar								--dA: apparently deprecated
		adjustHPBar = true,
		hideBlizPPB = false,
		ppbX = 0,
		ppbY = 0,
		ppbScale = 1,
		ppbAlpha = 1,
		
		lbf = 
		{
			Skills = {},
			Auras = {},
		},
		
		-- icd
		icd = 
		{
			visibility = 
			{
				ready = 1,
				cd = 3,
			},
		},

		rotation = 
		{
			--dA: normal queue		(single-target by default)
			prio = "efc ss wog sor jsw cs j asgc hwf as hw es lh how hpr cons",			--dA: revised
			prio_eft = "efc sor jsw cs j asgc hwf as hw es lh how hpr cons",			--dA: added, default if prio == ""
			prio_wog = "ss wog sor jsw cs j asgc hwf as hw es lh how hpr cons",			--dA: added, default if prio == ""
			--dA: alternate queue	(multi-target by default)
			defaultPrioAlt = false,
			prioAlt = "efc ss wog horwb sor jsw hor j asgc hwf as hw es lh how cons hpr", 	--dA: revised
			prioAlt_eft = "efc horwb sor jsw hor j asgc hwf as hw es lh how cons hpr",		--dA: added, default if prioAlt == ""
			prioAlt_wog = "ss wog horwb sor jsw hor j asgc hwf as hw es lh how cons hpr",	--dA: added, default if prioAlt == ""

			--dA: action configuration settings ---------------------------------------------------
			--dA: Eternal Flame 		(--dA: all added)
			--dA: first ef configuration - continuous use
			efcHP = 3,					--dA: min. HP to use efc ordinarily (range 1 - 5)
			efcRefresh = 6,				--dA: refresh efc at x seconds left (range 0 - 12)
			efcBoG = 2,					--dA: min. BoG stacks to use efc (range 0 - 5)
			efcxpHP = 3,				--dA: min. HP to use efc if not active (range 1 - 3)
			efcBoGhp = 3,				--dA: min. HP to use expiring BoG for efc (range 1 - 5)
			efcBoGstk = 2,				--dA: min. expiring BoG stack to use efc (range 1 - 5)
			efcBoGxp = 4,				--dA: min. secs. left to use BoG for efc (range 3 - 12)
			--DP
			efcdpRefresh = 6,			--dA: refresh efc at x seconds left (range 0 - 12)
			efcdpBoG = 2,				--dA: min. BoG stacks to use efc (range 0 - 5)
			efcdpBoGstk = 2,			--dA: min. expiring BoG stack to use efc (range 1 - 5)
			efcdpBoGxp = 4,				--dA: min. secs. left to use BoG for efc (range 3 - 12)
			--HA
			efchaHP = 3,				--dA: min. HP to use efc during HA (range 1 - 5)
			efchaRefresh = 10,			--dA: refresh efc at x seconds left (range 0 - 12)
			efchaBoG = 4,				--dA: min. BoG stack to use efc (range 0 - 5)
			efchaBoGhp = 3,				--dA: min. HP to use expiring BoG for efc (range 1 - 5)
			efchaBoGstk = 4,			--dA: min. expiring BoG stack to use efc (range 1 - 5)
			efchaBoGxp = 4,				--dA: min. secs. left to use BoG for efc (range 3 - 12)
			--SW
			efcswHP = 3,				--dA: min. HP to use efc during SW
			efcswRefresh = 10,			--dA: refresh efc at x seconds left (range 0 - 12)
			efcswBoG = 3,				--dA: min. BoG stacks to use efc (range 0 - 5)
			efcswBoGhp = 3,				--dA: min. HP to use expiring BoG for efc (range 1 - 5)
			efcswBoGstk = 3,			--dA: min. expiring BoG stack to use efc (range 1 - 5)
			efcswBoGxp = 4,				--dA: min. secs. left to use BoG for efc (range 3 - 12)
			
			--dA: second ef configuration - situational use
			efgHP = 3,					--dA: min. HP to use efg ordinarily (range 1 - 5)
			efgBoG = 3,					--dA: min. BoG stacks to use efg (range 0 - 5)
			efgHealth = 75,				--dA: min. Health remaining to use efg (range 21 - 100)
			--DP
			efgdpBoG = 2,				--dA: min. BoG stacks to use efg (range 0 - 5)
			efgdpHealth = 75,			--dA: refresh efg at y seconds left (range 0 - 10)
			--HA
			efghaHP = 3,				--dA: min. HP to use efg during HA (range 1 - 5)
			efghaBoG = 4,				--dA: min. BoG stacks to use efg (range 0 - 5)
			efghaHealth = 75,			--dA: refresh efg at y seconds left (range 0 - 10)
			--SW
			efgswHP = 3,				--dA: min. HP to use efg during SW (range 1 - 5)
			efgswBoG = 2,				--dA: min. BoG stacks to use efg (range 0 - 5)
			efgswHealth = 75,			--dA: refresh efg at y seconds left (range 0 - 10)

			-- word of glory
			wogHp = 3,					--dA: min HP to use WoG ordinarily (range 1 - 5)
			wogBasStack = 3,			--dA: min BoG stacks to use WoG ordinarily (range 0 - 5)
			wogPercent = 75,			--dA: max PC Health % to use WoG ordinarily (range 21 - 100)
			--DP
			wogdpBasStack = 3,			--dA: added, min. BoG stacks to use free cast during DP (range 0 - 5)
			wogdpPercent = 75,			--dA: added, max. PC Health % to use free cast during DP (range 21 - 100)
			--HA
			woghaHp	= 3, 				--dA: added, min. HP to use WoG during HA (range 1 - 5)
			woghaBasStack = 4,			--dA: added, min. BoG stacks to use WoG during HA (range 0 - 5)
			woghaPercent = 75,			--dA: added, max. PC health % to use WoG during HA (range 21 - 100)
			--SW
			wogswHp	= 3, 				--dA: added, min. HP to use WoG during SW (range 1 - 5)
			wogswBasStack = 2,			--dA: added, min. BoG stacks to use WoG during SW (range 0 - 5)
			wogswPercent = 75,			--dA: added, max. PC health % to use WoG during SW (range 21 - 100)

			--Shield of the Righteous 	
			sorHP = 3,					--dA: added, min. HP to use SoR ordinarily (range 3 - 5)
			sorBoGstk = 3,				--dA: added, min. BoG stack to refresh before expiration (range 1 - 5)
			sorBoGxp = 7,				--dA: added, refresh BoG @ __ secs. left in duration (range 3 - 12) 
			--DP
			sordpHP = 3,				--dA: added, min. HP to use free cast during DP (range 0 - 5)
			sor_dptr = 3.000,			--dA: secs. left for DivPurp at which proc is used unconditionally for SoR (range 3 - 6)
			--HA
			sorhaHP = 3,				--dA: added, min. HP to use SoR during HA (range 3 - 5)
			--SW
			sorswHP = 3,				--dA: added, min. HP to use SoR during AW with SW (range 3 - 5)
				
			--other actions 
			sasRefresh = 6,				--dA: refresh ss at min. secs. left (range 3 - 12)
			wbHPlimit = false,			--dA: true while WB allowed if HP >= 5 (config toggle) 
			wbRefresh = 6,				--dA: refresh wb at min. secs. left (range 3 - 12)
			consMana = 52,				--dA: min. percentage of mana remaining to cast Consecration

			--Action Sequence Timing 	--dA: optional configurations

			--dA: added to the value calculated for action.GetCD() to return when s1 == actionId
			csSpan = 0.000,				
			horSpan = 0.000,
			howSpan = 0.000,
			jSpan = 0.000,

			--dA: minimum time remaining necessary to act
			r_bas_min = 0.500,			--dA: min. BoG stack time left for valid comparisons to configs 
			r_dp_min = 0.500,			--dA: min. DP proc time left for valid comparisons to configs
			r_ef_min = 0.500,			--dA: min. EF buff time left for valid comparisons to configs
			r_sas_min = 0.500,			--dA: min. SS buff time left for valid comparisons to configs
			r_wb_min = 0.500,			--dA: min. WB debuff time left for valid comparisons to configs
		},
		
		-- behavior
		updatesPerSecond = 10,
		updatesPerSecondAuras = 5,
		rangePerSkill = false,
	
		-- layout of the 2 skill buttons
		layout = 
		{
			button1 = 
			{
				size = 70,
				alpha = 1,
				x = 0,
				y = 0,
				point = "CENTER",
				pointParent = "CENTER",
			},
			button2 = 
			{
				size = 40,
				alpha = 1,
				x = 50,
				y = 0,
				point = "BOTTOMLEFT",
				pointParent = "BOTTOMRIGHT",
			},
		},
		
		-- aura buttons
		-- 4 examples, rest init to "blank" later
		auras = {},
	}
}  	--dA: end of defaults -----------------------------------------------------=

--dA: found only in clcret.lua:  clcret.db_defaults = defaults

-- blank rest of the auras buttons in default options
for i = 1, MAX_AURAS do 
	defaults.profile.auras[i] = {
		enabled = false,
		data = {
			exec = "AuraButtonExecNone",
			spell = "",
			unit = "",
			byPlayer = true,
		},
		layout = {
			size = 30,
			x = 0,
			y = 0,
			alpha = 1,
			point = "BOTTOM",
			pointParent = "TOP",
		},
	}
end

local ceAuraApplied = {
	["SPELL_AURA_APPLIED"] = true,
	["SPELL_AURA_REFRESH"] = true,
	["SPELL_AURA_APPLIED_DOSE"] = true,
}

local ceAuraRemoved = {
	["SPELL_AURA_REMOVED"] = true,
	["SPELL_AURA_REMOVED_DOSE"] = true,
}

-- icd related stuff

-- helper functions 
--dA: I found "Helper Functions" at the bottom of this file and moved them here
-- ---------------------------------------------------------------------------------------------------------------------
-- HELPER FUNCTIONS
-- ---------------------------------------------------------------------------------------------------------------------	

  --dA: as of 2014-06-24, functions preceded & followed with comment-out notation are never called in any CLCProt .lua file

function clcprot:ToggleRotation(flag)
	if useAltPrio then
		useAltPrio = false
		prioToggled = "qn"
	else
		useAltPrio = true
		prioToggled = "qa"
	end
end	

function clcprot:Toggle_wbHPlimit()
	if allowWBhpmax then 
		allowWBhpmax = false
	else
		allowWBhpmax = true
	end
end
---[[
function clcprot:AuraButtonResetTextures()					--dA: not called in any CLCProt .lua file
	for i = 1, MAX_AURAS do
		auraButtons[i].hasTexture = false
	end
end

function clcprot:AuraButtonResetTexture(index)				
	auraButtons[index].hasTexture = false
end

function clcprot:AuraButtonHide(index)						--dA: not called in any CLCProt .lua file
	auraButtons[index]:Hide()
end
--]]

-- reversed and edged cooldown look for buffs and debuffs
function clcprot:UpdateAuraButtonsCooldown()
	for i = 1, MAX_AURAS do
		if (db.auras[i].data.exec == "AuraButtonExecGenericBuff") or (db.auras[i].data.exec == "AuraButtonExecGenericDebuff") then
			auraButtons[i].cooldown:SetReverse(true)
		else
			auraButtons[i].cooldown:SetReverse(false)
		end
	end
end

-- update the used aura buttons to shorten the for
function clcprot:UpdateEnabledAuraButtons()
	numEnabledAuraButtons = 0
	enabledAuraButtons = {}
	for i = 1, MAX_AURAS do
		if db.auras[i].enabled then
			numEnabledAuraButtons = numEnabledAuraButtons + 1
			enabledAuraButtons[numEnabledAuraButtons] = i
		end
	end
end

---[[
-- reports min icd for a specified aura button
function clcprot:ICDReportMinCd(args)						--dA: not called in any CLCProt .lua file
	local id = tonumber(args)
	if icd.data[id] then
		print("clcprot:", icd.data[id].mincd)
	else
		print("clcprot:", "No data found")
	end
end
--]]

-- check the aura list and enables cleu if needed, also resets all data
function clcprot:AuraButtonUpdateICD()
	icd.spells = {}
	icd.data = {}
	icd.cleu = false

	for i = 1, MAX_AURAS do
		if db.auras[i].data.exec == "AuraButtonExecICDItem" and db.auras[i].data.spell ~= "" and db.auras[i].enabled then
			local id = tonumber(db.auras[i].data.spell)
			local durationICD, durationBuff = strsplit(":", db.auras[i].data.unit)
			durationICD = tonumber(durationICD) or 0
			durationBuff = tonumber(durationBuff) or 0
			
			icd.cleu = true
			icd.spells[id] = i
			icd.data[i] = { id = db.auras[i].data.spell, durationICD = durationICD, durationBuff = durationBuff, start = 0, enabled = false, active = false, last = 0, mincd = 10000 }
		end
	end
	-- register/unregister combat log proccessing
	self:RegisterCLEU()
end

function clcprot:RegisterCLEU()
	if icd.cleu then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	else
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end
end

-- cleu dispatcher wannabe
function clcprot:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, combatEvent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, spellType, dose, ...)
	
	-- return if no icd
	if not icd.cleu then return end
	
	-- icd logic
	if destName == playerName and icd.spells[spellId] then
		local i = icd.spells[spellId]
		if ceAuraApplied[combatEvent] then
			icd.data[i].start = GetTime()
			icd.data[i].cd = floor(icd.data[i].start - icd.data[i].last + 0.5)
			icd.data[i].last = icd.data[i].start
			-- check if it's a smaller cd than the one used
			if icd.data[i].start > 0 and icd.data[i].cd < icd.data[i].durationICD then
				print("clcprot:", "Warning: " .. spellId .. "(" .. GetSpellInfo(spellId) .. ") activated after " .. icd.data[i].cd .. " seconds and specified ICD is " .. icd.data[i].durationICD .. " seconds.")
			end
			-- save min cd
			if icd.data[i].cd < icd.data[i].mincd then icd.data[i].mincd = icd.data[i].cd end
			icd.data[i].enabled = true
			icd.data[i].active = true
		end
	end
end

-----------------------------------------------------------------------------------------------------------------------
-- talent flag and glyph functions 
-----------------------------------------------------------------------------------------------------------------------

function FlagL45Talent()						--dA: new function; 

	local index = 0
	local name = ""
	local selected = false
		
	for index = 7, 9 do
		name, _, _, _, selected = GetTalentInfo(index)
		if ( selected ) then 								--dA: returns true if talent selected, false otherwise
			if index == 7 then 
				s_sht = true
				s_eft = false
				s_sst = false
			elseif index == 8 then 
				s_sht = false
				s_eft = true 
				s_sst = false
			elseif index == 9 then 
				s_sht = false
				s_eft = false
				s_sst = true 
			end
			if name then return name end
		end
	end 
	return "NO TIER 3 LEVEL 45 TALENT!"
end

function FlagL75Talent()									--dA: new function; 

	local index = 0
	local name = ""
	local selected = false
		
	for index = 13, 15 do
		name, _, _, _, selected = GetTalentInfo(index)
		if ( selected ) then 								--dA: returns true if talent selected, false otherwise
			if index == 13 then 
				s_hat = true
				s_swt = false
				s_dpt = false
			elseif index == 14 then 
				s_hat = false
				s_swt = true 
				s_dpt = false
			elseif index == 15 then 
				s_hat = false
				s_swt = false
				s_dpt = true 
			end
			if name then return name end
		end
	end 
--	print("CLCProt: rotation [", rota, "] FlagL75Talent() s_hat: ", s_hat, " s_swt: ", s_swt, " s_dpt: ", s_dpt, " name: ", name)
	return "NO TIER 5 LEVEL 75 TALENT!"
end

function FlagL90Talent()									--dA: new function; 

	local index = 0
	local name = ""
	local selected = false
	
	for index = 16, 18 do
		name, _, _, _, selected = GetTalentInfo(index)
		if selected then 									--dA: returns true if talent selected, false otherwise
			if index == 16 then 
				s_hprt = true
				s_lht  = false
				s_est  = false
			elseif index == 17 then 
				s_hprt = false
				s_lht  = true
				s_est  = false
			elseif index == 18 then 
				s_hprt = false
				s_lht  = false
				s_est  = true
			end
			if name then return name end
		end
	end 
	return "NO TIER 6 LEVEL 90 TALENT!"
end

function IsGlyphInSocket(glyphId)				--dA: adapted from prior source; returns true when the glyph is socketed

	local index = 0  

	if ( glyphId ) and type(glyphId) == "number" and glyphId > 0 then
		for index = 1, NUM_GLYPH_SLOTS do
			local enabled, _, _, glyphID = GetGlyphSocketInfo(index)
			if enabled then						--dA: enabled is nil if socket is locked (cannot be used yet)
				if glyphID == glyphId then
					return true
				end
			end
		end
		return false
	else
		print("CLCProt: clcprot IsGlyphInSocket(glyphId) received invalid glyphId: ", glyphId) 
	end
end


-- ---------------------------------------------------------------------------------------------------------------------
-- MAIN UPDATE FUNCTION
-- ---------------------------------------------------------------------------------------------------------------------
local throttle = 0
local throttleAuras = 0
local throttleGlyph = 0
local throttleTalent = 0
local function OnUpdate(self, elapsed)
	throttle = throttle + elapsed
	if throttle > clcprot.scanFrequency then
		throttle = 0
		clcprot:CheckQueue()											--dA: see clcprot:PLAYER_TALENT_UPDATE() 
		clcprot:CheckRange()
	end

	throttleAuras = throttleAuras + elapsed
	if throttleAuras > clcprot.scanFrequencyAuras then
		throttleAuras = 0
		for i = 1, numEnabledAuraButtons do
			-- TODO: check docs to see how it's done properly			--dA: nothing inspires confidence like the truth :-0
			auraIndex = enabledAuraButtons[i]
			clcprot[db.auras[auraIndex].data.exec]()
		end
	end
end
-- ----------------------------------------------------------------------------=


-- ---------------------------------------------------------------------------------------------------------------------
-- INIT
-- ---------------------------------------------------------------------------------------------------------------------
function clcprot:ProfileChanged(db, sourceProfile)
	-- relink 
	ReloadUI()
end
-- load if needed and show options
local function ShowOptions()
	if not clcprot.optionsLoaded then LoadAddOn("CLCProt_Options") end
	InterfaceOptionsFrame_OpenToCategory("CLCProt")
end
local function CmdLinePrio(args)
	clcprot.db.profile.rotation.prio = args
	clcprot.RR_UpdateQueue()
end
local function CmdLinePrioAlt(args)
	clcprot.db.profile.rotation.prioAlt = args
	clcprot.RR_UpdateQueue()
end
function clcprot:OnInitialize()
	-- SAVEDVARS
	self.db = LibStub("AceDB-3.0"):New("clcprotDB", defaults)
	self.db.RegisterCallback(self, "OnProfileChanged", "ProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "ProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "ProfileChanged")
	db = self.db.profile

	-- this would give a proper init
	self:RegisterEvent("QUEST_LOG_UPDATE")
end
function clcprot:QUEST_LOG_UPDATE()

	self:UnregisterEvent("QUEST_LOG_UPDATE")
		
	self.CheckQueue = self.DoNothing
	
	self.LBF = LibStub('LibButtonFacade', true)
	
	-- update rates
	self.scanFrequency = 1 / db.updatesPerSecond
	self.scanFrequencyAuras = 1 / db.updatesPerSecondAuras

	t_rspan = self.scanFrequency 	--dA: time span between the start of a rotation and the start of the next rotation

	-- blank options page for title
	local optionFrame = CreateFrame("Frame", nil, UIParent)
	optionFrame.name = "CLCProt"
	local optionFrameLoad = CreateFrame("Button", nil, optionFrame, "UIPanelButtonTemplate")
	optionFrameLoad:SetWidth(150)
	optionFrameLoad:SetHeight(22)
	optionFrameLoad:SetText("Load Options")
	optionFrameLoad:SetPoint("TOPLEFT", 20, -20)
	optionFrameLoad:SetScript("OnClick", ShowOptions)
	InterfaceOptions_AddCategory(optionFrame)
	-- chat command that points to our category
	self:RegisterChatCommand("clcprot", ShowOptions)
	self:RegisterChatCommand("clcprotlp", CmdLinePrio)
	self:RegisterChatCommand("clcprotlpalt", CmdLinePrioAlt)

	if not db.fullDisable then
		self:RegisterEvent("PLAYER_TALENT_UPDATE")
	end
	
	self:UpdateEnabledAuraButtons()

	--dA: the order in which these calls are now made enables RR_UpdateQueue() to use the flags set in PLAYER_TALENT_UPDATE
	self:InitUI()
	self:UpdateAuraButtonsCooldown()
	self:PLAYER_TALENT_UPDATE()
	self:RR_UpdateQueue()
	
	if self.LBF then
		self.LBF:RegisterSkinCallback("clcprot", self.OnSkin, self)
		self.LBF:Group("clcprot", "Skills"):Skin(unpack(db.lbf.Skills))
		self.LBF:Group("clcprot", "Auras"):Skin(unpack(db.lbf.Auras))
	end

	-- icd stuff
	self:AuraButtonUpdateICD()
	
	--[[ DEBUG
	self:InitDebugFrame()
	--]]
end

function clcprot:OnSkin(skin, glossAlpha, gloss, group, _, colors)
	local styleDB
	if group == 'Skills' then
		styleDB = db.lbf.Skills
	elseif group == 'Auras' then
		styleDB = db.lbf.Auras
	end

	if styleDB then
		styleDB[1] = skin
		styleDB[2] = glossAlpha
		styleDB[3] = gloss
		styleDB[4] = colors
	end
	
	self:UpdateAuraButtonsLayout()
	self:UpdateSkillButtonsLayout()
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- SHOW WHEN SETTINGS
-- ---------------------------------------------------------------------------------------------------------------------

-- updates the settings from db and register/unregisters the needed events

function clcprot:UpdateShowMethod()							--dA: called in clcprot:PLAYER_TALENT_UPDATE()
	-- unregister all events first
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	self:UnregisterEvent("PLAYER_REGEN_DISABLED")
	self:UnregisterEvent("PLAYER_TARGET_CHANGED")
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	self:UnregisterEvent("UNIT_FACTION")

	--------------------
	-- set the current db
	local saveDB = db
	db = clcprot.db.profile.rotation

	if db.defaultPrioAlt then
		useAltPrio = true
		print("CLCProt: default priority sequence is Alternate: ", db.prioAlt)
	else
		useAltPrio = false
		print("CLCProt: default priority sequence is Normal: ", db.prio)
	end

	if db.wbHPlimit then
		allowWBhpmax = true
	end

	db = saveDB
	--------------------

	if db.show == "combat" then
		if addonEnabled then
			if UnitAffectingCombat("player") then
				self.frame:Show()
			else
				self.frame:Hide()
			end
		end
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		self:RegisterEvent("PLAYER_REGEN_DISABLED")
		
	elseif db.show == "valid" or db.show == "boss" then
		self:PLAYER_TARGET_CHANGED()
		self:RegisterEvent("PLAYER_TARGET_CHANGED")
		self:RegisterEvent("PLAYER_ENTERING_WORLD", "PLAYER_TARGET_CHANGED")
		self:RegisterEvent("UNIT_FACTION")
	else
		if addonEnabled then
			self.frame:Show()
		end
	end
end

-- out of combat
function clcprot:PLAYER_REGEN_ENABLED()
	if not addonEnabled then return end
	self.frame:Hide()
end
-- in combat
function clcprot:PLAYER_REGEN_DISABLED()
	if not addonEnabled then return end
	self.frame:Show()
end
-- target change
function clcprot:PLAYER_TARGET_CHANGED()
	if not addonEnabled then return end
	
	if db.show == "boss" then
		if UnitClassification("target") ~= "worldboss" then
			self.frame:Hide()
			return
		end
	end
	
	if UnitExists("target") and UnitCanAttack("player", "target") and (not UnitIsDead("target")) then
		self.frame:Show()
	else
		self.frame:Hide()
	end
end
-- unit faction changed - test if it gets fired everytime a target switches friend -> enemy
function clcprot:UNIT_FACTION(event, unit)
	if unit == "target" then
		self:PLAYER_TARGET_CHANGED()
	end
end

-- disable/enable according to spec
function clcprot:PLAYER_TALENT_UPDATE()
	if db.fullDisable then
		self:CLCPROTDisable()
		return
	end
	
	-- check primary talent tree		--dA: so .... where does -that- happen? not in the prior source!

	local spec = GetSpecialization()
	if spec ~= 2 then
		self.CheckQueue = self.DoNothing
		self:CLCPROTDisable()
	else
		self:clcprotEnable()

		--dA: Blizzard broke PLAYER_TALENT_UPDATE during Warlords of Draenor development and has not corrected the problem,
		----: which is that, when the paladin enters a dungeon or raid, PTU is called six times, and when the paladin returns 
		----: from a dungeon or raid, PTU is again called six times. These calls result in -each- of the three messages for
		----: the L45, L75, and L90 talents, respectively, being output to the General tab of the Chat Frame six times.

		if ptuCount == 0 then
			-- * flag the current Tier 3 Level 45 talent --
			L45name = FlagL45Talent()
			if L45name then print("CLCProt: ", L45name, "is selected.") end
			
			-- * flag the current Tier 5 Level 75 talent --
			L75name = FlagL75Talent()
			if L75name then print("CLCProt: ", L75name, " is selected.") end 

			-- * get the Tier 6 Level 90 talent spell ID --
			L90Name = FlagL90Talent()
			if L90Name then print("CLCProt: the Tier 6 Level 90 talent is ", L90Name) end
			ptuCount = ptuCount + 1

		elseif ptuCount > 0 then
			-- * flag the current Tier 3 Level 45 talent --
			local p_L45name = L45name							--dA: local L45name init empty string 
			L45name = FlagL45Talent()
			if L45name and p_L45name ~= L45name then print("CLCProt: ", L45name, "is now selected.") end

			-- * flag the current Tier 5 Level 75 talent --
			local p_L75name = L75name							--dA: local L75name init empty string 
			L75name = FlagL75Talent()
			if L75name and p_L75name ~= L75name then print("CLCProt: ", L75name, " is now selected.") end 

			-- * get the Tier 6 Level 90 talent spell ID --
			local p_L90name = L90Name							--dA: global L90Name init empty string 
			L90Name = FlagL90Talent()
			if L90Name and p_L90name ~= L90Name then print("CLCProt: the Tier 6 Level 90 talent now is ", L90Name) end
			ptuCount = ptuCount + 1

		end 

		-- * check whether Glyph of Consecration is in effect *
		local consGlyphId			= 54928	 -- Glyph of Consecration 
		local consIdGlyphed			= 116467 -- consecration with gylph
		local consIdNoGlyph			= 26573  -- consecration without glyph 	
		s_goc = IsGlyphInSocket(consGlyphId)					--dA: global s_goc init false		
		if ( s_goc ) and consId == consIdNoGlyph then 
			consId = consIdGlyphed
			print("CLCProt: Consecration is targeted (Glyph of Consecration).")
		elseif ( not s_goc ) and consId == consIdGlyphed then
			consId = consIdNoGlyph
			print("CLCProt: Consecration is centered at the paladin (default).")
		end

		-- * check whether Glyph of Final Wrath is in effect *
		local fwGlyphId				= 54935	-- Glyph of Final Wrath
		local gfw_save = s_gfw									--dA: save current status of the glyph
		s_gfw = IsGlyphInSocket(fwGlyphId)						--dA: global s_gfw init false
		if ( s_gfw ) and ( not gfw_save ) then 
			print("CLCProt: Final Wrath for Holy Wrath is in effect.")
		elseif ( not s_gfw ) and (gfw_save) then
			print("CLCProt: Glyph of Final Wrath has been removed.")
		end

		self.CheckQueue = self.CheckQueueProt				--dA: CheckQueueProt() calls clcprot.ProtRotation() 
		dq[1], dq[2] = 31935, 31935							--dA: 31935 is avenger's shield id 
		self:UpdateShowMethod()	
	end
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- UPDATE FUNCTIONS
-- ---------------------------------------------------------------------------------------------------------------------
-- just show the button for positioning
function clcprot:AuraButtonExecNone(index)
	auraButtons[auraIndex]:Show()
end

-- shows a skill always with a visible cooldown when needed
function clcprot:AuraButtonExecSkillVisibleAlways()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	-- fix the texture once
	if not button.hasTexture then
		button.hasTexture = true
		button.texture:SetTexture(GetSpellTexture(data.spell))
	end
	
	button:Show()
	
	if IsUsableSpell(data.spell) then
		button.texture:SetVertexColor(1, 1, 1, 1)
	else
		button.texture:SetVertexColor(0.3, 0.3, 0.3, 1)
	end
	
	local start, duration = GetSpellCooldown(data.spell)
	if duration and duration > 0 then
		button.cooldown:SetCooldown(start, duration)
	end
end

-- shows a skill only when out of cooldown
function clcprot:AuraButtonExecSkillVisibleNoCooldown()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	-- fix the texture once
	if not button.hasTexture then
		button.hasTexture = true
		button.texture:SetTexture(GetSpellTexture(data.spell))
	end

	local start, duration = GetSpellCooldown(data.spell)
	
	if IsUsableSpell(data.spell) then
		button.texture:SetVertexColor(1, 1, 1, 1)
	else
		button.texture:SetVertexColor(0.3, 0.3, 0.3, 1)
	end
	
	if duration and duration > 1.5 then
		button:Hide()
	else
		button:Show()
	end
end

-- shows a skill only when on cooldown
function clcprot:AuraButtonExecSkillVisibleOnCooldown()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	-- fix the texture once
	if not button.hasTexture then
		button.hasTexture = true
		button.texture:SetTexture(GetSpellTexture(data.spell))
	end

	local start, duration = GetSpellCooldown(data.spell)
	
	if duration and duration > 1.5 then
		button:Show()
		button.cooldown:SetCooldown(start, duration)
	else
		button:Hide()
	end
end

-- shows an equiped usable item always with a visible cooldown when needed
function clcprot:AuraButtonExecItemVisibleAlways()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	-- hide the item if is not equiped						--dA: prior source
	--[[
	if not IsEquippedItem(data.spell) then
		button:Hide()
		return
	end
	--]]
	
	-- fix the texture once
	if not button.hasTexture then
		button.hasTexture = true
		button.texture:SetTexture(GetItemIcon(data.spell))
	end
	
	button:Show()
	
	if IsUsableItem(data.spell) then
		button.texture:SetVertexColor(1, 1, 1, 1)
	else
		button.texture:SetVertexColor(0.3, 0.3, 0.3, 1)
	end
	
	local start, duration = GetItemCooldown(data.spell)
	if duration and duration > 0 then
		button.cooldown:SetCooldown(start, duration)
	end

end

-- shows shows an equiped usable item only when out of cooldown
function clcprot:AuraButtonExecItemVisibleNoCooldown()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	-- hide the item if is not equiped						--dA: prior source
	--[[
	if not IsEquippedItem(data.spell) then
		button:Hide()
		return
	end
	--]]
	
	-- fix the texture once
	if not button.hasTexture then
		button.hasTexture = true
		button.texture:SetTexture(GetItemIcon(data.spell))
	end

	local start, duration = GetItemCooldown(data.spell)
	
	if IsUsableItem(data.spell) then
		button.texture:SetVertexColor(1, 1, 1, 1)
	else
		button.texture:SetVertexColor(0.3, 0.3, 0.3, 1)
	end
	
	if duration and duration > 1.5 then
		button:Hide()
	else
		button:Show()
	end
end

-- displayed when a specific spell isn't active on player
function clcprot:AuraButtonExecPlayerMissingBuff()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	if not button.hasTexture then
		button.texture:SetTexture(GetSpellTexture(data.spell))
		button.hasTexture = true
	end
	
	local name, rank, icon, count, debuffType, duration, expirationTime, caster = UnitBuff("player", data.spell)
	if not name then
		button:Show()
	else
		button:Hide()
	end
end

-- experimental item with icd stuff
-- states:
--	no icd
--  buff active
--  icd
function clcprot:AuraButtonExecICDItem()
	local index = auraIndex
	local button = auraButtons[index]
	local data = icd.data[index]
	
	if not button.hasTexture then
		local _, _, tex = GetSpellInfo(data.id)
		button.texture:SetTexture(tex)
		button.hasTexture = true
	end

	local gt = GetTime()
	if (gt - data.start) > data.durationBuff then data.active = false end
	if (gt - data.start) > data.durationICD then data.enabled = false end
	
	if data.active then 
		-- always show the button when proc is active
		button:Show()
		button.cooldown:Show()
		button.cooldown:SetCooldown(data.start, data.durationBuff)
		button:SetAlpha(1)
		
	elseif data.enabled then
		-- check how to display
		if db.icd.visibility.cd == 1 then
			button:Show()
			button:SetAlpha(1)
		elseif db.icd.visibility.cd == 2 then
			button:Show()
			button:SetAlpha(0.3)
		else
			button:Hide()
			return
		end
		
		button.cooldown:Show()
		button.cooldown:SetCooldown(data.start, data.durationICD)
	else
		if db.icd.visibility.ready == 1 then
			button:Show()
			button:SetAlpha(1)
		elseif db.icd.visibility.ready == 2 then
			button:Show()
			button:SetAlpha(0.5)
		else
			button:Hide()
		end
		
		button.cooldown:Hide()
	end
end

-- checks for a buff by player (or someone) on unit
function clcprot:AuraButtonExecGenericBuff()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	if not UnitExists(data.unit) then
		button:Hide()
		return
	end
	
	local name, rank, icon, count, debuffType, duration, expirationTime, caster = UnitBuff(data.unit, data.spell)
	if name then
		if data.byPlayer and (caster ~= "player") then
			-- player required and not found
			button:Hide()
		else
			-- found the debuff
			if duration and duration > 0 then
				button.cooldown:SetCooldown(expirationTime - duration, duration)
			end
			
			-- fix texture once
			if not button.hasTexture then
				button.texture:SetTexture(icon)
				button.hasTexture = true
			end
			
			button:Show()
			
			if count > 1 then
				button.stack:SetText(count)
				button.stack:Show()
			else
				button.stack:Hide()
			end
		end
	else
		button:Hide()
	end
end

-- checks for a debuff cast by player (or someone) on unit
function clcprot:AuraButtonExecGenericDebuff()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	if not UnitExists(data.unit) then
		button:Hide()
		return
	end
	
	local name, rank, icon, count, debuffType, duration, expirationTime, caster = UnitDebuff(data.unit, data.spell)
	if name then
		if data.byPlayer and (caster ~= "player") then
			button:Hide()
		else
			-- found the debuff
			if duration and duration > 0 then
				button.cooldown:SetCooldown(expirationTime - duration, duration)
			end
			
			-- fix texture once
			if not button.hasTexture then
				button.texture:SetTexture(icon)
				button.hasTexture = true
			end
			
			button:Show()
			
			if count > 1 then
				button.stack:SetText(count)
				button.stack:Show()
			else
				button.stack:Hide()
			end
		end
	else
		button:Hide()
	end
end

-- resets the vertex color when grayOOM option changes
function clcprot:ResetButtonVertexColor()
	buttons[1].texture:SetVertexColor(1, 1, 1, 1)
	buttons[2].texture:SetVertexColor(1, 1, 1, 1)
end

-- updates the 2 skill buttons
function clcprot:UpdateUI()
	-- queue
	for i = 1, 2 do
		local button = buttons[i]
		local _, _, texture = GetSpellInfo(dq[i])
		button.texture:SetTexture(texture)
		
		local start, duration = GetSpellCooldown(dq[i])
		if duration and duration > 0 then
			button.cooldown:Show()
			button.cooldown:SetCooldown(start, duration)
		else
			button.cooldown:Hide()
		end
		
		if db.grayOOM then
			local _, nomana = IsUsableSpell(nq[i])
			if nomana then 
				button.texture:SetVertexColor(0.3, 0.3, 0.3, 0.3)
			else
				button.texture:SetVertexColor(1, 1, 1, 1)
			end
		end
		
	end
end

-- melee range check
function clcprot:CheckRange()

--dA: do not check range or show melee range for AoE spells targeted with the mouse 
----: s1_twm and s2_twm are flagged true in clcprot.ProtRotation() (in rotation.lua)

	local range
	if db.rangePerSkill then
		-- each skill shows the range of the ability
		for i = 1, 2 do
			if i == 1 and ( s1_twm ) then 
				s1_twm = false				
			elseif i == 2 and ( s2_twm ) then 
				s2_twm = false		
			elseif type(nq[i]) == "string" then 
				range = IsSpellInRange(nq[i], "target")
				if range ~= nil and range == 0 then
					buttons[i].texture:SetVertexColor(0.8, 0.1, 0.1)
				else
					buttons[i].texture:SetVertexColor(1, 1, 1)
				end
			else
				local argtype = type(nq[i])
			end 
		end
	else
		-- both skills show melee range
		range = IsSpellInRange(hrname, "target")	
		if range ~= nil and range == 0 then
			for i = 1, 2 do
				if i == 1 and ( s1_twm ) then 
					s1_twm = false
				elseif i == 2 and ( s2_twm ) then 
					s2_twm = false		
				else
					buttons[i].texture:SetVertexColor(0.8, 0.1, 0.1)
				end
			end
		else
			for i = 1, 2 do
				if i == 1 and ( s1_twm ) then 
					s1_twm = false
				elseif i == 2 and ( s2_twm ) then 
					s2_twm = false		
				else
					buttons[i].texture:SetVertexColor(1, 1, 1)
				end
			end
		end
	end
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- QUEUE LOGIC
-- ---------------------------------------------------------------------------------------------------------------------
-- holy blank function
function clcprot:DoNothing()
	self:CLCPROTDisable()
end

function clcprot:CheckQueueProt()
	dq[1], dq[2] = clcprot.ProtRotation()					--dA: clcprot.ProtRotation() is at end of rotation.lua 

	nq[1] = GetSpellInfo(dq[1])
	nq[2] = GetSpellInfo(dq[2])

	self:UpdateUI()
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- ENABLE/DISABLE
-- ---------------------------------------------------------------------------------------------------------------------
function clcprot:clcprotEnable()
	if addonInit then
		addonEnabled = true
		self.frame:Show()
	end
end

function clcprot:CLCPROTDisable()
	if addonInit then
		addonEnabled = false
		self.frame:Hide()
	end
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- UPDATE LAYOUT
-- ---------------------------------------------------------------------------------------------------------------------

-- toggle main frame for drag
function clcprot:ToggleLock()
	if self.locked then
		self.locked = false
		self.frame:EnableMouse(true)
		self.frame.texture:Show()
	else
		self.locked = true
		self.frame:EnableMouse(false)
		self.frame.texture:Hide()
	end
end

-- center the main frame
function clcprot:CenterHorizontally()
	db.x = (UIParent:GetWidth() - clcprotFrame:GetWidth() * db.scale) / 2 / db.scale
	self:UpdateFrameSettings()
end

-- update for aura buttons 
function clcprot:UpdateSkillButtonsLayout()
	clcprotFrame:SetWidth(db.layout.button1.size + 10)
	clcprotFrame:SetHeight(db.layout.button1.size + 10)
	
	for i = 1, 2 do
		self:UpdateButtonLayout(buttons[i], db.layout["button" .. i])
	end
end

-- update aura buttons 
function clcprot:UpdateAuraButtonsLayout()
	for i = 1, MAX_AURAS do
		self:UpdateButtonLayout(auraButtons[i], db.auras[i].layout)
	end
end

-- update aura for a single button (tmp use in options)
function clcprot:UpdateAuraButtonLayout(index)
	self:UpdateButtonLayout(auraButtons[index], db.auras[index].layout)
end

-- update a given button
function clcprot:UpdateButtonLayout(button, opt)
	local scale = opt.size / button.defaultSize
	button:SetScale(scale)
	button:ClearAllPoints()
	button:SetPoint(opt.point, clcprotFrame, opt.pointParent, opt.x / scale, opt.y / scale)
	button:SetAlpha(opt.alpha)
	button.border:SetVertexColor(unpack(db.borderColor))
	button.border:SetTexture(borderType[db.borderType])
	
	button.stack:ClearAllPoints()
	button.stack:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 4, 0)
	
	if db.zoomIcons then
		button.texture:SetTexCoord(0.05, 0.95, 0.05, 0.95)
	else
		button.texture:SetTexCoord(0, 1, 0, 1)
	end
	
	if db.noBorder then
		button.border:Hide()
	else
		button.border:Show()
	end
end

-- update scale, alpha, position for main frame
function clcprot:UpdateFrameSettings()
	self.frame:SetScale(max(db.scale, 0.01))
	-- clcprot.myppbParent:SetScale(max(db.scale, 0.01) * UIParent:GetScale())
	self.frame:SetAlpha(db.alpha)
	self.frame:SetPoint("BOTTOMLEFT", db.x, db.y)
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- INIT LAYOUT
-- ---------------------------------------------------------------------------------------------------------------------

BINDING_HEADER_CLCPROT = "CLCProt"
BINDING_NAME_TOGGLEROTATION = "Toggle Rotation"
-- initialize main frame and all the buttons
function clcprot:InitUI()
	local frame = CreateFrame("Frame", "clcprotFrame", UIParent)
	frame.unit = "player"
	frame:SetFrameStrata(strataLevels[db.strata])
	frame:SetWidth(db.layout.button1.size + 10)
	frame:SetHeight(db.layout.button1.size + 10)
	frame:SetPoint("BOTTOMLEFT", db.x, db.y)
	
	frame:EnableMouse(false)
	frame:SetMovable(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", function(self) self:StartMoving() end)
	frame:SetScript("OnDragStop", function(self)
		self:StopMovingOrSizing()
		db.x = clcprotFrame:GetLeft()
		db.y = clcprotFrame:GetBottom()
	end)
	
	local texture = frame:CreateTexture(nil, "BACKGROUND")
	texture:SetAllPoints()
	texture:SetTexture(BGTEX)
	texture:SetVertexColor(0, 0, 0, 1)
	texture:Hide()
	frame.texture = texture

	self.frame = frame
	
	-- init main skill button
	local opt
	opt = db.layout["button1"]
	buttons[1] = self:CreateButton("SB1", opt.size, opt.point, clcprotFrame, opt.pointParent, opt.x, opt.y, "Skills", true)
	buttons[1]:SetAlpha(opt.alpha)
	buttons[1]:Show()
	
	-- init secondary skill button
	opt = db.layout["button2"]
	buttons[2] = self:CreateButton("SB2", opt.size, opt.point, clcprotFrame, opt.pointParent, opt.x, opt.y, "Skills")
	buttons[2]:SetAlpha(opt.alpha)
	buttons[2]:Show()
	
	-- aura buttons
	self:InitAuraButtons()
	
	-- set scale, alpha, position
	self:UpdateFrameSettings()
	
	addonInit = true
	self:CLCPROTDisable()
	self.frame:SetScript("OnUpdate", OnUpdate)
end

-- initialize aura buttons
function clcprot:InitAuraButtons()
	local data, layout
	for i = 1, MAX_AURAS do
		data = db.auras[i].data
		layout = db.auras[i].layout
		auraButtons[i] = self:CreateButton("aura"..i, layout.size, layout.point, clcprotFrame, layout.pointParent, layout.x, layout.y, "Auras")
		auraButtons[i].start = 0
		auraButtons[i].duration = 0
		auraButtons[i].expirationTime = 0
		auraButtons[i].hasTexture = false
	end
end

-- create button
function clcprot:CreateButton(name, size, point, parent, pointParent, offsetx, offsety, bfGroup, isChecked)
	name = "clcprot" .. name
	local button
	if isChecked then
		button = CreateFrame("CheckButton", name , parent)
		button:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square", "ADD")
		button:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight", "ADD")
	else
		button = CreateFrame("Button", name , parent)
	end
	button:EnableMouse(false)
	
	button:SetWidth(64)
	button:SetHeight(64)
	
	button.texture = button:CreateTexture("$parentIcon", "BACKGROUND")
	button.texture:SetAllPoints()
	button.texture:SetTexture(BGTEX)
	
	button.border = button:CreateTexture(nil, "BORDER") -- not $parentBorder so it can work when bf is enabled
	button.border:SetAllPoints()
	button.border:SetTexture(BORDERTEX)
	button.border:SetVertexColor(unpack(db.borderColor))
	button.border:SetTexture(borderType[db.borderType])
	
	button.cooldown = CreateFrame("Cooldown", "$parentCooldown", button)
	button.cooldown:SetAllPoints(button)
	
	button.stack = button:CreateFontString("$parentCount", "OVERLAY", "TextStatusBarText")
	local fontFace, _, fontFlags = button.stack:GetFont()
	button.stack:SetFont(fontFace, 30, fontFlags)
	button.stack:SetJustifyH("RIGHT")
	button.stack:ClearAllPoints()
	button.stack:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 4, 0)
	
	button.defaultSize = button:GetWidth()
	local scale = size / button.defaultSize
	button:SetScale(scale)
	button:ClearAllPoints()
	button:SetPoint(point, parent, pointParent, offsetx / scale, offsety / scale)
	
	if self.LBF then
		self.LBF:Group("clcprot", bfGroup):AddButton(button)
	end
	
	if db.zoomIcons then
		button.texture:SetTexCoord(0.05, 0.95, 0.05, 0.95)
	end
	
	if db.noBorder then
		button.border:Hide()
	end
	
	button:Hide()
	return button
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- FULL DISABLE
-- ToDo: Unregister/Register all events here ?
------------------------------------------------------------------------------------------------------------------------
function clcprot:FullDisableToggle()
	if db.fullDisable then
		-- enabled
		db.fullDisable = false
		
		-- register events
		self:RegisterEvent("PLAYER_TALENT_UPDATE")
		self:RegisterCLEU()
		
		-- do the normal load rutine
		self:PLAYER_TALENT_UPDATE()
	else
		-- disabled
		db.fullDisable = true
		
		-- unregister events
		self:UnregisterEvent("PLAYER_TALENT_UPDATE")
		
		self:UnregisterEvent("PLAYER_REGEN_ENABLED")
		self:UnregisterEvent("PLAYER_REGEN_DISABLED")
		self:UnregisterEvent("PLAYER_TARGET_CHANGED")
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self:UnregisterEvent("UNIT_FACTION")
		
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		
		-- disable
		self:CLCPROTDisable()
	end
end
-- ---------------------------------------------------------------------------------------------------------------------

--- END OF FILE ---------------------------------------------------------------=